exports.handler = async (event) => {
  return new Promise((resolve,reject) => {
    orchestrator.Authenticate()
        .then ( key => {
            orchestrator.StartJob()
              .then(result => resolve(result))
              .catch(reason => reject(reason))
          })
          .catch(reason => reject(reason))     
  })
}


var orchestrator = {}
var axios = require('axios')

var instance = axios.create({
  baseURL: 'Enter URL of Orchesrator e.g. https://xyz.com',
  timeout: 1000,
  headers: {'Authorization': 'Bearer '+orchestrator.bearerToken}
});

orchestrator.bearerToken = ''


orchestrator.Authenticate = async () => {
  return new Promise((resolve,reject) => {
        return instance({
          method: 'post',
          url: '/api/Account/Authenticate',
          data: {
            "tenancyName": "Enter Tenant Name e.g. Default",
            "usernameOrEmailAddress": "Enter User Name",
            "password": "Enter Password"
          }
        }).then(result => {
          orchestrator.bearerToken = result.data.result
          resolve(true)
        })
      })    
  }

orchestrator.StartJob = async () => {  
  return new Promise ((resolve, reject) => {
    instance({
      method:'post',
      url:'/odata/Jobs/UiPath.Server.Configuration.OData.StartJobs',
      headers: {'Authorization': 'Bearer '+orchestrator.bearerToken},
      data: {
            "startInfo": {
                          "ReleaseKey": "Enter The Release Key. You can get the Release Key from /odata/Releases command",
                          "Strategy": "Specific",
                          "RobotIds": "Enter The Bot Id e.g. [14400]. You can get the Bot Id using odata/Sessions command. ",
                          "NoOfRobots": 0,
                          "Source": "Manual"
                        }
      }
    })
    .then(result => {
      resolve(result)
    })
    .catch(reason => reject(reason))
  })
}

